using System;
using System.Collections.Generic;
using System.Text;
using WindowsLive.Writer.Api;
using System.Windows.Forms;
using WindowsLive.Writer.Extensibility.BlogClient;
using WindowsLive.Writer.PostEditor;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace WLWtwitter
{
    [WriterPlugin("7E113E74-A693-4bcd-8CF8-4C73265469CC", "Tweet It", ImagePath = "Twit.png", PublisherUrl = "http://krishnan.co.in", Description = "a new twitter plugin")]

    [InsertableContentSource("Tweet It")]

    public class TwitIt:PublishNotificationHook
    {
        public override void OnPostPublish(IWin32Window owner, IProperties properties, IPublishingContext publishingContext, bool publish)
        {
            if (publish)
            {
                
                if (string.IsNullOrEmpty(publishingContext.PostInfo.Permalink))
                {
                    PluginDiagnostics.LogError("TwitterNotify didn't execute, due to blank permalink");
                }
                else if (properties.GetBoolean("Send", true))
                {
                    if (MessageBox.Show("Submit to Twitter ?", "Tweet It", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    {
                        string result = "Nothing";
                        if (publishingContext.HomepageUrl == "http://download-songs.in")
                        {
                            result = "To Songs - " + PostTweet("Twitter User Name1", "password", publishingContext.PostInfo.Title, publishingContext.PostInfo.Permalink);
                        }
                        else if (publishingContext.HomepageUrl == "http://www.twinsblog.net/")
                        {
                            result = "To Twins - " + PostTweet("Twitter User Name2", "password", publishingContext.PostInfo.Title, publishingContext.PostInfo.Permalink);
                        }
                        else if (publishingContext.HomepageUrl == "http://krishnan.co.in/blog")
                        {
                            result = "To Krishnans - " + PostTweet("Twitter User Name3", "password", publishingContext.PostInfo.Title, publishingContext.PostInfo.Permalink);
                        }
                        else
                        {
                            result = publishingContext.HomepageUrl;
                        }
                        MessageBox.Show(result);
                    }
                }
            }
        }

        private static string getTinyUrl(string ur)
        {
            System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
            if (!cmpUrl.IsPrefix(ur, "http://tinyurl.com"))
            {
                string address = "http://tinyurl.com/api-create.php?url=" + ur;
                System.Net.WebClient client = new System.Net.WebClient();
                return (client.DownloadString(address));
            }
            else
            {
                return (ur);
            }
        }

        private static string getBbitly(string url)
        {
            string bitlyUsername = "";
            string bitlyAPIKey = "";
            System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
            if (!cmpUrl.IsPrefix(url, "http://tinyurl.com"))
            {
                string address = "http://api.bit.ly/shorten?version=2.0.1&longUrl=" + url + "&login=" + bitlyUsername + "&apiKey=" + bitlyAPIKey + "&history=1";
                System.Net.WebClient client = new System.Net.WebClient();
                string result = client.DownloadString(address);
                string[] result1 = result.Split(',');
                result = result1[4].Replace("\"shortUrl\": \"", "").Replace("\"", "").Replace(" ", "");
                return (result);
            }
            else
            {
                return (url);
            }
        }

        private static bool checkUrl(string url)
        {
            if (url.Trim() != "")
            {
                Regex RgxUrl = new Regex("http(s)?://([\\w-]+\\.)+[\\w-]+(/[\\w- ./?%&=]*)?");
                if (RgxUrl.IsMatch(url))
                {
                    return (true);
                }
                else
                {
                    return (false);
                }
            }
            else
            {
                return (false);
            }
        }

        private static string PostTweet(string username, string password, string tweet, string ur)
        {
            try
            {
                ur = checkHttp(ur);
                string user = Convert.ToBase64String(System.Text.Encoding.UTF8.GetBytes(username + ":" + password));
                if (ur.Trim() != "")
                {
                    if (checkUrl(ur))
                    {
                        ur = getBbitly(ur);
                    }
                    else
                    {
                        MessageBox.Show(ur);
                        return ("Invalid URL");
                    }
                }
                byte[] bytes = System.Text.Encoding.ASCII.GetBytes("status=" + tweet + " " + ur);
                HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://twitter.com/statuses/update.xml");
                request.Method = "POST";
                request.ServicePoint.Expect100Continue = false;
                request.Headers.Add("Authorization", "Basic " + user);
                request.ContentType = "application/x-www-form-urlencoded";
                request.ContentLength = bytes.Length;
                Stream reqStream = request.GetRequestStream();
                reqStream.Write(bytes, 0, bytes.Length);
                reqStream.Close();
                return ("Success");
            }
            catch (Exception ex)
            {
                return (ex.Message);
            }
        }

        private static string checkHttp(string url)
        {
            System.Globalization.CompareInfo cmpUrl = System.Globalization.CultureInfo.InvariantCulture.CompareInfo;
            if (cmpUrl.IsPrefix(url, "http://") == false && cmpUrl.IsPrefix(url, "https://") == false && url.Trim() != "")
            {
                url = "http://" + url;
            }
            return (url);
        }

    }
}
